Index: channels/chan_zap.c
===================================================================
--- channels/chan_zap.c	(revision 53911)
+++ channels/chan_zap.c	(working copy)
@@ -128,6 +128,11 @@
 #define ZT_EVENT_DTMFUP 0
 #endif
 
+/* FIXME: a temporary def until zaptel.h is synced: Issue 7256 */
+#ifndef ZT_EVENT_REMOVED
+#define ZT_EVENT_REMOVED (20)
+#endif
+
 /* define this to send PRI user-user information elements */
 #undef SUPPORT_USERUSER
 
@@ -7048,6 +7053,12 @@
 				"polarity reversal on non-FXO (SIG_FXS) "
 				"interface %d\n", i->channel);
 		}
+	case ZT_EVENT_REMOVED: /* destroy channel */
+		ast_log(LOG_NOTICE, 
+				"Got ZT_EVENT_REMOVED. Destroying channel %d\n", 
+				i->channel);
+		zap_destroy_channel_bynum(i->channel);
+		break;
 	}
 	pthread_attr_destroy(&attr);
 	return 0;
@@ -10607,16 +10618,11 @@
 
 #endif /* HAVE_PRI */
 
-static int zap_destroy_channel(int fd, int argc, char **argv)
+/* destroy a zaptel channel, identified by its number */
+static int zap_destroy_channel_bynum(int channel)
 {
-	int channel = 0;
 	struct zt_pvt *tmp = NULL;
 	struct zt_pvt *prev = NULL;
-	
-	if (argc != 4) {
-		return RESULT_SHOWUSAGE;
-	}
-	channel = atoi(argv[3]);
 
 	tmp = iflist;
 	while (tmp) {
@@ -10630,6 +10636,20 @@
 	return RESULT_FAILURE;
 }
 
+static int zap_destroy_channel(int fd, int argc, char **argv)
+{
+	int channel = 0;
+	struct zt_pvt *tmp = NULL;
+	struct zt_pvt *prev = NULL;
+	
+	if (argc != 4) {
+		return RESULT_SHOWUSAGE;
+	}
+	channel = atoi(argv[3]);
+
+	return zap_destroy_channel_bynum(channel);
+}
+
 static int setup_zap(int reload);
 static int zap_restart(void)
 {
